/* 1- Use punteros para implementar pasajes de parmetros por referencia. Este programa debe permitir cargar los datos de un alumno en un registro. El pasaje de este registro como parmetro de la funcin 'ingresar_datos()' debe llevarse a cabo por referencia, haciendo uso de la direccin de memoria de l.*/
/* Solucin en lenguaje C*/

#include <stdio.h>
#include <string.h>

/* Tipo registro para almacenar un alumno */
typedef struct {
	long padron;
	char nombre[50];
	float notas[3];
	} t_alumno;

void ingresar_datos(t_alumno *alumno)
{
	printf("Ingrese los datos del alumno:\n\n");

	printf("Padrn: ");
	scanf("%ld", &(alumno->padron));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nombre: ");
	fgets(alumno->nombre, 50, stdin);
	if (alumno->nombre[strlen(alumno->nombre)-1] == '\n')
		alumno->nombre[strlen(alumno->nombre)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nota 1: ");
	scanf("%f", &(alumno->notas[0]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nota 2: ");
	scanf("%f", &(alumno->notas[1]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nota 3: ");
	scanf("%f", &(alumno->notas[2]));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */
}

int main()
{
	t_alumno alumno;
	float promedio;
	/* Observar el pasaje por referencia usando */
	/* la direccin del registro. */
	ingresar_datos( &alumno );

	promedio = (alumno.notas[0]+alumno.notas[1]+alumno.notas[2])/3;
	printf("\n");
	printf("Padrn: %ld\n", alumno.padron);
	printf("Nombre y apellido: %s\n", alumno.nombre);
	printf("Promedio de notas: %.2f\n", promedio);
	printf("\n");

	return 0;
}