/* 4- Ordene por burbujeo un arreglo de caracteres mediante aritmtica de punteros.*/
/*Solucin en lenguaje C*/
/*El arreglo de entrada se recibe como parmetro por lnea de comandos.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Prototipo */
void ordenar(char datos[], int n);

/* Programa Principal */
int main(int argc, char *argv[])
{
	char *datos, *ptr;
	long n;
	if (argc != 2)
	{
	fprintf(stderr, "Modo de uso: %s <cadena>\n", argv[0]);
	exit(1);
	}
	datos = argv[1];
	n = strlen(datos);

	/* Ordenamiento */
	ordenar(datos, n);

	printf("Arreglo ordenado: ");
	for (ptr=datos; ptr<(datos+n); ptr++)
	printf("%c ", *ptr);
	printf("\n");

	return 0;
}

void ordenar(char datos[], int n)
{
	char *ptr1, *ptr2, aux;

	/* 'ptr1' comienza apuntando al ltimo elemento del arreglo */
	/* y desciende hasta terminar apuntando al primer elemento. */
	/* 'ptr2' se mueve desde el primer elemento hasta el ante- */
	/* rior a 'ptr1'. */
	for (ptr1 = datos+n-1; ptr1 >= datos; ptr1--)
		for (ptr2 = datos; ptr2 < ptr1; ptr2++)
			if ( *ptr2 > *(ptr2+1) )
			{
			/* Intercambio */
			aux = *ptr2;
			*ptr2 = *(ptr2+1);
			*(ptr2+1) = aux;
			}
}