{1- Use punteros para implementar pasajes de parmetros por referencia. Este programa debe permitir cargar los datos de un alumno en un registro. El pasaje de este registro como parmetro de la funcin 'ingresar_datos()' debe llevarse a cabo por referencia, haciendo uso de la direccin de memoria de l.}
{Solucin en lenguaje Pascal}

PROGRAM cap10_ej01;

{ Tipo registro para almacenar un alumno }
TYPE t_alumno = RECORD
	padron: LONGINT;
	nombre: STRING[50];
	notas: ARRAY[1..3] OF REAL;
	END;
	t_ptr_alumno = ^t_alumno;

PROCEDURE ingresar_datos(alumno: t_ptr_alumno);
BEGIN
	WRITELN('Ingrese los datos del alumno:');
	WRITELN;

	WRITE('Padrn: ');
	READLN(alumno^.padron);

	WRITE('Nombre: ');
	READLN(alumno^.nombre);

	WRITE('Nota 1: ');
	READLN(alumno^.notas[1]);

	WRITE('Nota 2: ');
	READLN(alumno^.notas[2]);

	WRITE('Nota 3: ');
	READLN(alumno^.notas[3]);
END;

VAR alumno: t_alumno;
	promedio: REAL;
{ Programa Principal }
BEGIN
	{ Observar el pasaje por referencia usando }
	{ la direccin del registro. }
	ingresar_datos( @alumno );
	promedio := (alumno.notas[1]+alumno.notas[2]+alumno.notas[3])/3;

	WRITELN;
	WRITELN('Padrn: ', alumno.padron);
	WRITELN('Nombre y apellido: ', alumno.nombre);
	WRITELN('Promedio de notas: ', promedio:4:2);
	WRITELN;
END.