/* 3- En lenguajes de programacin como C y Pascal, las matrices se almacenan linealmente en memoria. Existen dos esquemas: Si se almacenan las filas una tras otra, hablamos de orden por filas (por ejemplo, en C y Pascal), y si se almacenan las columnas una tras otra, el orden es por columnas (Fortran). Esto significa que, en la prctica, una matriz puede recorrerse con un solo ndice. Tome una matriz de nmeros enteros y busque el mayor. Para ello se pide hacer uso de un solo ndice y aritmtica de punteros.*/
/* Solucin en lenguaje C*/

#include <stdio.h>

#define N 5
#define TAMANIO (N*N)

int main()
{
	int *ptr, mayor=0;
	int matriz[N][N] = { { 19, 83, 7, 39, 21},
	{ 66, 1, 39, 70, 12},
	{ 21, 54, 29, 91, 30},
	{ 14, 27, 4, 87, 39},
	{ 5, 48, 24, 13, 8} };

/* Bsqueda del entero mayor. */
/* La matriz se recorre linealmente con un puntero y */
/* haciendo uso de aritmtica de punteros. */

/* 'ptr' apunta al primer elemento de la matriz */
for (ptr = &matriz[0][0]; ptr < (&matriz[0][0] + TAMANIO); ptr++)
	if ( *ptr > mayor )
	mayor = *ptr;

	printf("%d es el mayor nmero entero en la matriz.\n", mayor);
	return 0;
}
