{3- En lenguajes de programacin como C y Pascal, las matrices se almacenan linealmente en memoria. Existen dos esquemas: Si se almacenan las filas una tras otra, hablamos de orden por filas (por ejemplo, en C y Pascal), y si se almacenan las columnas una tras otra, el orden es por columnas (Fortran). Esto significa que, en la prctica, una matriz puede recorrerse con un solo ndice. Tome una matriz de nmeros enteros y busque el mayor. Para ello se pide hacer uso de un solo ndice y aritmtica de punteros.}
{Solucin en lenguaje Pascal}

PROGRAM cap10_ej03;

CONST N = 5;

TYPE t_matriz = ARRAY[1..N, 1..N] OF INTEGER;

VAR ptr: ^INTEGER;
	mayor: INTEGER;
	matriz: t_matriz;
	i, j: INTEGER;

{ Programa Principal }
BEGIN
	mayor := 0;
	{ La matriz se inicializa con enteros aleatorios positivos }
	RANDOMIZE;
	FOR i := 1 TO N DO
	FOR j := 1 TO N DO
	matriz[i,j] := RANDOM(100); { >= a 0 y < a 100}

	{ Bsqueda del entero mayor. }
	{ La matriz se recorre linealmente con un puntero y }
	{ haciendo uso de aritmtica de punteros. }
	{ 'ptr' apunta al primer elemento de la matriz }
	ptr := @matriz[1][1];
	WHILE (ptr <= @matriz[N][N]) DO
	BEGIN
		IF ( ptr^ > mayor ) THEN
		mayor := ptr^;
		INC(ptr);
	END;
	WRITELN(mayor, ' es el mayor nmero entero en la matriz.');
END.