{4- Ordene por burbujeo un arreglo de caracteres mediante aritmtica de punteros.}
{Solucin en lenguaje Pascal}

PROGRAM cap10_ej04;
{ El arreglo de datos debe pasarse por referencia: VAR }
PROCEDURE ordenar(VAR datos: STRING; n: INTEGER);

VAR ptr1, ptr2: ^CHAR;
aux: CHAR;

BEGIN
	{ 'ptr1' comienza apuntando al ltimo elemento del arreglo }
	{ y desciende hasta terminar apuntando al primer elemento. }
	{ 'ptr2' se mueve desde el primer elemento hasta el ante- }
	{ rior a 'ptr1'. }

	ptr1 := @datos[n];
	WHILE (ptr1 >= @datos[1]) DO
	BEGIN
		ptr2 := @datos[1];
		WHILE (ptr2 < ptr1) DO
		BEGIN
			IF ( ptr2^ > (ptr2+1)^ ) THEN
			BEGIN
				{ Intercambio }
				aux := ptr2^;
				ptr2^ := (ptr2+1)^;
				(ptr2+1)^ := aux;
			END;
			INC(ptr2);
		END;
		DEC(ptr1);
	END;
END;

VAR datos: STRING;
	n: INTEGER;
	ptr: ^CHAR;

{ Programa Principal }
BEGIN
	IF (PARAMCOUNT <> 1) THEN
	BEGIN
		WRITELN('Modo de uso: ', PARAMSTR(0), ' <cadena>');
		EXIT;
	END;

	datos := PARAMSTR(1);
	n := LENGTH(datos);

	{ Ordenamiento }
	ordenar(datos, n);
	WRITE('Arreglo ordenado: ');
	ptr := @datos[1];
	WHILE (ptr <= @datos[N]) DO
	BEGIN
		WRITE(ptr^, ' ');
		INC(ptr);
	END;
	WRITELN;
END.