{5- En este problema resuelto se busca ejemplificar el uso de punteros a funciones. Cree una rutina para el clculo de promedios, que sea lo suficientemente genrica y capaz de calcular el promedio sobre cualquier otra funcin que reciba un entero como parmetro y retorne un real de doble precisin. Para ejemplificar el uso de 'promedio()' construya dos funciones (lineal y cuadrtica). Para el problema en Pascal, si la compilacin se lleva a cabo con FreePascal deber usarse la opcin -Mtp que habilita la compatibilidad con TurboPascal (lo cual permite el pasaje de funciones y/o procedimientos como parmetros de otras funciones y/o procedimientos).}
{Solucin en lenguaje Pascal}

PROGRAM cap10_ej05;
TYPE t_func = FUNCTION(x: INTEGER): DOUBLE;

{ La funcin 'promedio()' es genrica, en el sentido de que }
{ es capaz de calcular el promedio de cualquier funcin }
{ recibida como parmetro. }
FUNCTION promedio(func: t_func; inicio, fin: INTEGER): DOUBLE;
VAR acum: DOUBLE;
	x: INTEGER;
BEGIN
	acum := 0;
	FOR x := inicio TO fin-1 DO
	acum := acum + func(x);
	promedio := acum / (fin - inicio);
END;

{ Funcin lineal: f(x) = x }
FUNCTION lineal(x: INTEGER): DOUBLE;
BEGIN
	lineal := x;
END;

{ Funcin cuadrtica: f(x) = x^2 }
FUNCTION cuadratica(x: INTEGER): DOUBLE;
BEGIN
	cuadratica := x*x;
END;

{ Programa Principal }
BEGIN
	WRITELN('Promedio de f(x) = x (0 <= x < 10) : ', promedio(lineal, 0, 10):6:2);
	WRITELN('Promedio de f(x) = x^2 (4 <= x < 6) : ', promedio(cuadratica, 4, 6):6:2);